<?xml version="1.0" encoding="UTF-8" standalone="yes"?>
<!-- 
####################################################################################
#  XSL name : annexB
#  Version : R2.0.8.S05                                        
#  Intermediate release number : 040-20210730                              
#  Last update : 14/04/2016                                                            
####################################################################################
 -->
 <xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="2.0">
	<!-- Pattern -->
	<xsl:template match="*[@FORM='1' or @FORM='2' or @FORM='4' or @FORM='5']//*[matches(local-name(),'DIV_INTO_LOT_YES')][not(child::*)] " mode="R237">
		<xsl:variable name="ele">
			<xsl:value-of select="local-name(.)"/> and annex B not used</xsl:variable>
		<xsl:call-template name="msg">
			<xsl:with-param name="rule" select="'R237'"/>
			<xsl:with-param name="content" select="$ele"/>
		</xsl:call-template>
		<xsl:apply-templates select="@*|*" mode="R237"/>
	</xsl:template>
	<xsl:template match="text()" priority="-1" mode="R237"/>
	<xsl:template match="@*|node()" priority="-2" mode="R237">
		<xsl:apply-templates select="@*|*" mode="R237"/>
	</xsl:template>
	<!-- Pattern -->
	<xsl:template match="*[@FORM='1' or @FORM='2' or @FORM='4' or @FORM='5'][.//@CTYPE='WORKS']//*[matches(local-name(),'DIV_INTO_LOT_YES')]/*" mode="R239">
		<xsl:choose>
			<xsl:when test="descendant::VALUE_COST[number(translate(text(),', ','.'))>0]"/>
			<xsl:when test="descendant::RANGE_VALUE_COST[number(translate(LOW_VALUE/text(),', ','.'))>0 and number(translate(HIGH_VALUE/text(),', ','.'))>number(translate(LOW_VALUE/text(),', ','.'))] "/>
			<xsl:otherwise>
				<xsl:variable name="ele">WORKS and (RANGE_)VALUE_COST missing/incorrect</xsl:variable>
				<xsl:call-template name="msg">
					<xsl:with-param name="rule" select="'R239'"/>
					<xsl:with-param name="content" select="$ele"/>
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
		<xsl:apply-templates select="@*|*" mode="R239"/>
	</xsl:template>
	<xsl:template match="text()" priority="-1" mode="R239"/>
	<xsl:template match="@*|node()" priority="-2" mode="R239">
		<xsl:apply-templates select="@*|*" mode="R239"/>
	</xsl:template>
</xsl:stylesheet>
